#include "share.h"

class  THIWinEnum:public TDebug
{
   private:
    string ReadParam();
   public:
    HWND FHandle;
    string FClassName;
    bool FStop;
    string _prop_Caption;
    bool _prop_VisibleOnly;
    THI_Event *_data_Caption;
    THI_Event *_event_onEnum;
    THI_Event *_event_onFindWindow;
    THI_Event *_event_onEndEnum;

    HI_WORK_LOC(THIWinEnum,_work_doEnum);
    HI_WORK_LOC(THIWinEnum,_work_doFind);
    HI_WORK(_work_doStop){ _hie(THIWinEnum)->FStop = true; }

    HI_WORK( _var_Handle){ CreateData(_Data,(int)_hie(THIWinEnum)->FHandle); }
    HI_WORK( _var_ClassName){ CreateData(_Data,_hie(THIWinEnum)->FClassName); }
    HI_WORK( _var_GetActiveWindow){ CreateData(_Data,(int)GetForegroundWindow()); }
};

//######################################################################

string THIWinEnum::ReadParam()
{
   HI_RSTRING buf[512];
   buf[ GetWindowText(FHandle,buf,512) ] = 0;
   string Result(buf);

   buf[ GetClassName(FHandle,buf,512) ] = 0;
   FClassName = buf;

   return Result;
}

void THIWinEnum::_work_doFind(TData &_Data,WORD Index)
{  
   string cpt = ReadString(_Data,_data_Caption,_prop_Caption);
    if( !cpt.Empty() )
   FHandle = FindWindow(NULL,PChar(cpt));
   if( FHandle )
      {ReadParam();
     _hi_onEvent(_event_onFindWindow,(int)FHandle);}
}

void THIWinEnum::_work_doEnum(TData &_Data,WORD Index)
{                           
   FStop = false;            
   FHandle = GetWindow(GetForegroundWindow(),GW_HWNDFIRST);
   bool fl;
   while( !FStop && FHandle )
   {
      fl = true;
      if( _prop_VisibleOnly == true )
        fl &= IsWindowVisible(FHandle);

      if( fl ) _hi_onEvent(_event_onEnum,ReadParam());

      FHandle = GetWindow(FHandle,GW_HWNDNEXT);
   }
   _hi_onEvent(_event_onEndEnum);
}
